
void blink_buzzer()
{
    sound=!sound;
    digitalWrite(BUZZER_LED_ON_12,sound); 
    digitalWrite(SIRENA,sound);
    
}


//timer ticker settato ogni 1 ms per gestire il fitro chiave hardware
//e verificare che la scheda sia sempre attiva facendo il blink del led.
//non usare interrupt timer dato che singolarmente funziona perfettamente ma con wifi crasha il sistema
void timer0 (void) {   //scatta ogni 1 ms

  if(tempot>0)tempot--;

  if(check_key)
  {
    if(timer_key>0)timer_key--;
  }
  if(timer_delay>0)timer_delay--;
  
  if(tempot==0)
  {
    tempot=1000;
    //Serial.println("timer scattato");
    if(timer_connect>0)timer_connect--;
    
    if(abiita_antifurto) // se ho girato la chiave in modalità attiva
    {
      if(timer_abilitazione_allarme>0)
      {
        timer_abilitazione_allarme--; 
        blink_buzzer();
      }
  
      if(movimento_rilevato)  //se antifurto abilitato e ho un movimento rilevato
      {
        if(timer_disabilitazione_allarme>0)
        {
          blink_buzzer();
          timer_disabilitazione_allarme--; 
        }
        
      }
    }
    
  }
                                 
}




//La gestione della chiave è fatta con un filtro che permette di eliminare eventuali sporcizie
//per vedere il cambiamento di stato devo avere per almeno 100ms il segnale costante .
//inoltre se la chiave cambia di stato ed è attiva mi permette di abilitare l'antifurto.
//nel momento in cui abilito l'antifurto ho x secondi di tempo prima che venga abilitato il sensore pir.
//questo per dare tempo all'utente di uscire di casa altrimenti rileverebbe subito il movimento.

void gestione_chiave_hw()
{
    
    chiave_inserita = digitalRead(KEY_HW);  // legge il valore dell'input e lo conserva  

    if(old_chiave_inserita!=chiave_inserita) //se cè un cambiamento abilito timer e carico 100ms
    {
      check_key=true;
      timer_key=100;
      old_chiave_inserita = chiave_inserita;
    }
    
    if ((chiave_inserita == HIGH)&&(timer_key==0)) {   //se il timer arriva
      if(check_key)
      {
        check_key=false;                               //disabilito controllo chiave  
        Serial.println(F("Antifurto attivato"));            //stampo lo stato chiave
        movimento_rilevato=false;
        abiita_antifurto=true;
        timer_abilitazione_allarme=TEMPO_ABILITA_ALLARME;  //carico tempo prima che si abiliti antifurto
        
      }
    }
    else if ((chiave_inserita == LOW)&&(timer_key==0)) {
      if(check_key)
      {
        check_key=false;                               //disabilito controllo chiave  
        Serial.println(F("Antifurto disattivato"));        //stampo lo stato chiave
        abiita_antifurto=false;
        digitalWrite(BUZZER_LED_ON_12,LOW); 
        digitalWrite(SIRENA,LOW);
      }
    }
}

void gestione_pir()
{
  if((abiita_antifurto)&&(timer_abilitazione_allarme==false))  //se ho girato chiave e sono passati i secondi
  {
    
    if(digitalRead(PIR_SENSOR))
    {
      if(movimento_rilevato ==false)
      {
        movimento_rilevato=true;
        Serial.println(F("MOVIMENTO RILEVATO"));        //
        timer_disabilitazione_allarme=TEMPO_DISABILITA_ALLARME;//parte timer disabilita
        invia_notifica=true;
      }
    }
  
  }  
  
}

short gestione_wifi(uint8_t modalita)
{
  short value=false;
  
  switch (modalita)
  {
    case CONNESSIONE:
      if(!is_connected)
      {
        WiFi.mode(WIFI_STA);
        WiFi.begin(ssid, password); //connessione rete wifi
        Serial.println();
        Serial.print("connessione rete WiFi");
        uint8_t i=0;
        while (WiFi.status() != WL_CONNECTED)
        {
            Serial.print(".");
            delay(500);
            i++;
            if(i>20)
            {
              is_connected=false;  //non sono riuscito a connettermi entro il tempo del timer
              value=false;
              return (value);
            }   
        }
        Serial.println("WiFi Connesso!");
        is_connected=true;
        value=true;
      }
     break;
     case DISCONNESSIONE:
       if(is_connected)
       {
          Serial.println("Sleeping...");   //eseguo sleep perchè in caso di disconnessione e riconnessione non evolve
          WiFi.disconnect();
          WiFi.mode(WIFI_OFF);
          WiFi.forceSleepBegin(sleepTime * 1000000L); //In uS. Must be same length as your delay
          delay(sleepTime * 1000); //Hang out at 15mA for 6 seconds
          WiFi.mode(WIFI_STA);
          Serial.println("Awake!");
          is_connected=false;             //ok non sono pù connesso
          value=true; 

       }
     break;
     default:
     break;
  }

  return (value);
}







